/* DBS Telephony Server (c) 1997-1998 Tycho Softworks.
 * $Id: keyterm.h 1.2 Sun, 11 Oct 1998 20:20:08 -0400 dyfet $
 *
 * This software is free software; permission is granted to use, modify
 * and redistribute this software as according to the terms of the GNU
 * General Public License as published by the Free Software Foundation;
 * either version 2, as found in the "COPYING" file distributed with this
 * software, or (at your option) any later version published by the
 * Free Software Foundation. 
 * 
 * This software is supplied "AS IS" WITHOUT ANY WARRANTY, EXPRESSED OR
 * IMPLIED; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public
 * License for further details. 
 */

#include <telephony/dbs.h>
#include <telephony/dbs_keys.h>
#include <std/time.h>
#include <std/types.h>

typedef	struct _kt
{
	time_t	timer;
#pragma	pack(1)
	uchar	kpos;
	uchar	kbuf[17];
#pragma pack()
	void	(*khandler)(struct _kt *kp, int ext, DBSMSG *);
}	KEYTERM;

extern	int	expire_timer;
extern	int	powerup_timer;
extern	int	event_timer;

void	down(int ex_code);
int	dispatch(void);
void	initkterm(void);
void	synckterm(void);
void	putkterm(int extension, DBSMSG *msg);
KEYTERM	*getkterm(int ext);

/* state handlers */

void	logout(KEYTERM *kp, int extension);
void	kt_init(KEYTERM *kp, int extension, DBSMSG *msg);
void	kt_login(KEYTERM *kp, int extension, DBSMSG *msg);

