/* DBS Telephony Server (c) 1997-1998 Tycho Softworks.
 * $Id: station.c 1.1 Sat, 10 Oct 1998 19:51:45 -0400 dyfet $
 *
 * This software is free software; permission is granted to use, modify
 * and redistribute this software as according to the terms of the GNU
 * General Public License as published by the Free Software Foundation;
 * either version 2, as found in the "COPYING" file distributed with this
 * software, or (at your option) any later version published by the
 * Free Software Foundation. 
 * 
 * This software is supplied "AS IS" WITHOUT ANY WARRANTY, EXPRESSED OR
 * IMPLIED; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public
 * License for further details. 
 */

#include <std/time.h> 
#include "keyterm.h"

/* Initial state */

void	kt_init(KEYTERM *kp, int extension, DBSMSG *msg)
{
	if(!msg)
		return;

	switch(dbs_getmsgtype(msg))
	{
	case DBS_KEYPAD_MSGTYPE:
		sleep(1);
	case DBS_APIKEY_MSGTYPE:
		dbs_monitor(0, extension, 3);
		dbs_display_line(0, extension, 0, "DBS Login");
		dbs_display_line(0, extension, 2, "System");
		dbs_display_line(0, extension, 3, "User");
		dbs_display_line(0, extension, 4, "Temp");
		dbs_display_line(0, extension, 5, "");
		dbs_display_line(0, extension, 6, "            Quit"); 
		kp->khandler = kt_login;
		time(&kp->timer);
		kp->timer += 60;
		kp->kpos = 0;
		return;
	default:
		return;
	}
}

