/* Portable System Interfaces Copyright (c) 1997-1998 Tycho Softworks.
 * $Id: _limits.c 1.1 Tue, 23 Jun 1998 11:38:33 -0400 dyfet $
 *
 * Permission is hear-by granted, free of charge, to any person obtaining
 * a copy of this software and associated documentation files (the
 * "Software"), to deal in the Software without restriction, including
 * without limitation the rights to use, copy, modify, merge, publish,
 * distribute with modifications, sub-license, and/or sell copies of the
 * software, and to permit persons to whom the Software is furnished to
 * do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included
 * in all copies or substantial portions of the Software.
 *
 * Neither the name of Tycho Softworks nor the names of it's contributors
 * may be used to endorse or promote products derived from this Software
 * without specific prior written permission.
 * 
 * THIS SOFTWARE IS PROVIDED BY TYCHO SOFTWORKS "AS IS" AND ANY EXPRESS
 * OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL TYCHO SOFTWORKS OR IT'S
 * CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
 * OR CONSEQUENTIAL DAMAGES (INCLUDING BUT NOT LIMITED TO, PROCUREMENT
 * OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR
 * BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
 * WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE
 * OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS "SOFTWARE",
 * EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

#include <std/process.h>
#include <std/math.h>
#include <std/select.h>

#ifndef	PATH_MAX
#define	PATH_MAX	1024
#endif

#ifndef	OPEN_MAX
#define	OPEN_MAX	sizeof(fd_set) * 8
#endif

int	limit_openmax(int limit)
{
	int	max;
#ifndef	SYSCONF_F_MISSING

	max = sysconf(_SC_OPEN_MAX);
	if(max > 0)
	{
		if(limit)
			return min(max, limit);
		return max;
	}
#endif
	if(limit)
		return min(limit, OPEN_MAX);

	return OPEN_MAX;
}

int	limit_pathmax(int limit, const char *path)
{
	int	max;

#ifndef	PATHCONF_F_MISSING
	max = pathconf(path, _PC_PATH_MAX);
	if(max > 0)
	{
		if(limit)
			return min(limit, max);
		return max;
	}
#endif
	if(limit)
		return min(limit, PATH_MAX);

	return PATH_MAX;
}

