/* Portable System Interfaces Copyright (c) 1997-1998 Tycho Softworks.
 * $Id: _stream.c 1.1 Tue, 23 Jun 1998 11:38:33 -0400 dyfet $
 *
 * Permission is hear-by granted, free of charge, to any person obtaining
 * a copy of this software and associated documentation files (the
 * "Software"), to deal in the Software without restriction, including
 * without limitation the rights to use, copy, modify, merge, publish,
 * distribute with modifications, sub-license, and/or sell copies of the
 * software, and to permit persons to whom the Software is furnished to
 * do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included
 * in all copies or substantial portions of the Software.
 *
 * Neither the name of Tycho Softworks nor the names of it's contributors
 * may be used to endorse or promote products derived from this Software
 * without specific prior written permission.
 * 
 * THIS SOFTWARE IS PROVIDED BY TYCHO SOFTWORKS "AS IS" AND ANY EXPRESS
 * OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL TYCHO SOFTWORKS OR IT'S
 * CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
 * OR CONSEQUENTIAL DAMAGES (INCLUDING BUT NOT LIMITED TO, PROCUREMENT
 * OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR
 * BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
 * WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE
 * OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS "SOFTWARE",
 * EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

#include <std/stream.h>

#ifdef	_CAP_STREAM_FILES

#ifdef	STROPTS_H_MISSING
#include <std/socket.h>

int	stream(fd_t fd[2])
{
	return socketpair(AF_UNIX, SOCK_STREAM, 0, fd);
}

#else
#include <std/process.h>
#include <std/paths.h>
#include <stropts.h>
#include <sys/stream.h>

#include <std/files.h>

int	stream(fd_t fd[2])
{
	struct	strfdinsert	ins;
	queue_t			*ptr;

	if((fd[0] = open(_PATH_DEV "spx", O_RDWR)) < 0)
		return -1;

	if((fd[1] = open(_PATH_DEV "spx", O_RDWR)) < 0)
	{
		close(fd[0]);
		return -1;
	}
	
	ins.ctlbuf.buf = (char *)&ptr;
	ins.ctlbuf.maxlen = sizeof(queue_t *);
	ins.ctlbuf.len = sizeof(queue_t *);

	ins.databuf.buf = NULL;
	ins.databuf.len = -1;
	ins.databuf.maxlen = 0;

	ins.fildes = fd[1];
	ins.flags = 0;
	ins.offset = 0;

	if(ioctl(fd[0], I_FDINSERT, (char *)&ins) < 0)
	{
		close(fd[0]);
		close(fd[1]);
		return -1;
	}
	return 0;
}

#endif

#endif
