/* Portable System Interfaces Copyright (c) 1997-1998 Tycho Softworks.
 * $Id: string.h 1.1 Tue, 23 Jun 1998 11:38:33 -0400 dyfet $
 *
 * Permission is hear-by granted, free of charge, to any person obtaining
 * a copy of this software and associated documentation files (the
 * "Software"), to deal in the Software without restriction, including
 * without limitation the rights to use, copy, modify, merge, publish,
 * distribute with modifications, sub-license, and/or sell copies of the
 * software, and to permit persons to whom the Software is furnished to
 * do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included
 * in all copies or substantial portions of the Software.
 *
 * Neither the name of Tycho Softworks nor the names of it's contributors
 * may be used to endorse or promote products derived from this Software
 * without specific prior written permission.
 * 
 * THIS SOFTWARE IS PROVIDED BY TYCHO SOFTWORKS "AS IS" AND ANY EXPRESS
 * OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL TYCHO SOFTWORKS OR IT'S
 * CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
 * OR CONSEQUENTIAL DAMAGES (INCLUDING BUT NOT LIMITED TO, PROCUREMENT
 * OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR
 * BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
 * WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE
 * OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS "SOFTWARE",
 * EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

#ifndef	__STD_STRINGS_H__
#define	__STD_STRINGS_H__

#ifndef	__STD_TYPES_H__
#include <std/types.h>
#endif

#include <string.h>

#ifndef	BSTRING_H_MISSING
#include <bstring.h>
#endif

#ifndef	STRCASECMP_F_MISSING
#ifdef	STRICMP_F_MISSING
#undef	STRICMP_F_MISSING
#define	stricmp(s1, s2)	strcasecmp(s1, s2)
#define	strnicmp(s1, s2, n) strncasecmp(s1, s2, n)
#endif
#endif

#ifdef	__cplusplus
extern "C" {
#endif

#define	__SPACES	__NAMESPACE(__SPACES)

extern	char	__SPACES[];

#ifdef	STRICMP_F_MISSING
#define	stricmp		__NAMESPACE(stricmp)
#define	strnicmp	__NAMESPACE(strnicmp)

int	stricmp(const char *s1, const char *s2);
int	strnicmp(const char *s1, const char *s2, size_t n);
#endif

#ifdef	STRLWR_F_MISSING

#define	strupr	__NAMESPACE(strupr)
#define	strlwr	__NAMESPACE(strlwr)

char	*strlwr(char *s1);
char	*strupr(char *s2);
#endif

#ifdef	STRDUP_F_MISSING

#define	strdup	__NAMESPACE(strdup)

char *strdup(const char *s);
#endif

#ifdef	STRISTR_F_MISSING
#define	stristr		__NAMESPACE(stristr)

char	*stristr(char *s1, const char *s2);
#endif

#define	strtrim	__NAMESPACE(strtrim)
#define	strltrim __NAMESPACE(strltrim)
#define	strrtrim __NAMESPACE(strrtrim)

char	*strtrim(char *str, const char *trim);
char	*strltrim(char *str, const char *trim);
char	*strrtrim(char *str, const char *trim);

#ifdef	__cplusplus
}
#endif

#endif
