/* Portable System Interfaces Copyright (c) 1997-1998 Tycho Softworks.
 * $Id: termios.h 1.1 Tue, 23 Jun 1998 11:38:33 -0400 dyfet $
 *
 * Permission is hear-by granted, free of charge, to any person obtaining
 * a copy of this software and associated documentation files (the
 * "Software"), to deal in the Software without restriction, including
 * without limitation the rights to use, copy, modify, merge, publish,
 * distribute with modifications, sub-license, and/or sell copies of the
 * software, and to permit persons to whom the Software is furnished to
 * do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included
 * in all copies or substantial portions of the Software.
 *
 * Neither the name of Tycho Softworks nor the names of it's contributors
 * may be used to endorse or promote products derived from this Software
 * without specific prior written permission.
 * 
 * THIS SOFTWARE IS PROVIDED BY TYCHO SOFTWORKS "AS IS" AND ANY EXPRESS
 * OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL TYCHO SOFTWORKS OR IT'S
 * CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
 * OR CONSEQUENTIAL DAMAGES (INCLUDING BUT NOT LIMITED TO, PROCUREMENT
 * OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR
 * BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
 * WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE
 * OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS "SOFTWARE",
 * EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

#ifndef	__STD_TERMIOS_H__
#define	__STD_TERMIOS_H__

#ifdef	TERMIOS_H_MISSING
#include <sys/ioctl.h>
#ifdef	TERMIO_H_MISSING
#include <gstty.h>
#else
#include <termio.h>
#endif
#else
#include <termios.h>
#endif

#ifndef CRTSCTS
#ifdef  CTSFLOW
#define CRTSCTS CTSFLOW | CRTSFL
#endif
#endif       

#ifdef	TERMIOS_H_MISSING

#define	TCSANOW		0
#define	TCSADRAIN	1
#define	TCSAFLUSH	2

#ifdef	TERMIO_H_MISSING

#define	NCC	8

typedef	unsigned short	tcflag_t;
typedef	unsigned char	cc_t;

struct	termios
{
	tcflag_t	c_iflag;
	tcflag_t	c_oflag;
	tcflag_t	c_cflag;
	tcflag_t	c_lflag;
	cc_t		c_cc[NCCS];
};

#else
#define	termios	termio
#endif

#ifdef	__cplusplus
extern "C" {
#endif

int	tcgetattr(int fd, struct termios *tp);
int	tcsetattr(int fd, struct termios *tp);

#ifdef	__cplusplus
}
#endif

#endif
#endif

